function f_cell2latex(tab_in,filename,tablename)
[nrows,ncols] = size(tab_in);
cc = repmat('c',1,ncols);
fid = fopen(filename,'w');

fprintf(fid,'\n\\documentclass{article} \n');
fprintf(fid,'\\begin{document} \n');
fprintf(fid,'\\begin{table}[htbp] \\centering \n');
fprintf(fid,['\\caption{',tablename,'\\label{key}} \n']);
fprintf(fid,'\\footnotesize \n');
fprintf(fid,'\\begin{tabular}{%s} \n',cc);
text_mat = [];
for i = 1:nrows
    text_row = [];
    for j = 1:ncols
        oneelement = tab_in{i,j};
        if (ischar(oneelement))
            oneelement(1,strfind(oneelement,'_')) = ' ';
            if (j==1)
                text_row = [ text_row oneelement];
            else
                text_row = [ text_row ' & ' oneelement];
            end
        end
        if (isnumeric(oneelement))
            if (j==1)
                text_row = [ text_row num2str(oneelement)];
            else
                text_row = [ text_row ' & ' num2str(oneelement)];
            end
        end
        if (j == ncols && i == nrows)
            text_row = [ text_row ' \n  '];
        end
        if (j == ncols && i ~= nrows)
            text_row = [ text_row ' \\\\ \n  '];
        end
    end
    fprintf(fid,text_row);
    text_mat = strvcat(text_mat,text_row); % text_mat
end
fprintf(fid,'\\end{tabular} \n');
fprintf(fid,'\\normalsize \n');
fprintf(fid,'\\end{table} \n');
fprintf(fid,'\\end{document} \n');
fclose(fid);



