function [year,per,freq] = dat2ypf(dat)
%
% DAT2YPF  Convert dates to year, period and frequency vectors.
%
% [y,p,f] = dat2ypf(dat)
% Arguments:
%   y, p, f, dat: numeric
%
% IRIS Toolbox 2006/03/28 

% -----function DAT2YPF body----- %

yp = floor(dat);
freq = round(100*(dat - yp));
index = freq == 0;

[year,per] = deal(nan(size(dat)));

per(index) = dat(index); % indeterminate frequency
year(~index)  = floor(yp(~index) ./ freq(~index));
per(~index) = round(yp(~index) - year(~index).*freq(~index) + 1);

end % of primary function