function f_table_var_prob(var_prob,names,var_sel_index); 
%
% Wahrscheinlichkeiten der einzelnen Variabllen

hmax = size(var_prob,2);
nrec = size(var_prob(1).prob_mat,2); 
n_names = size(names,1);
var_sel_index = [2,3,4,5,6,21,22];

hind = 1:1:hmax;
recnum = 1:1:nrec; 

% no colors default 
colordef white;
set(0,'DefaultAxesColorOrder',[0.0,0.0,0.0])
set(0,'DefaultAxesLineStyleOrder',{'-s','-o','-+','-*','-x','-^','.'});


% ***********************************************************
% Darstellung ber Prognosehorizont h  

% Auswahl der darzustellenden Rekursionen 
nnrec = [1; 15; 30];      

for i=1:size(nnrec,1)
    sel_nrec = nnrec(i,1);
    figure; newplot;
    s1r = [];
    for j=1:hmax
        s1r = [ s1r, var_prob(j).prob_mat(:,sel_nrec) ];
    end
    plot(hind,s1r(var_sel_index,:)); 
    legend(char(lower(deblank(names(var_sel_index,:)))));
    title( ['recursion = ',num2str(sel_nrec) ] ); 
    axis([1 hmax 0 1]); 
    set(gca,'XTick',[1:hmax],'XTickLabel',[1:hmax],'XTickMode','manual');
    set(gca,'FontSize',8);
end

% ***********************************************************
% Darstellung ber Rekursionen irec   

% Auswahl der darzustellenden Prognosehorizonte  
h_index = [1; 6; 12]; 
 
s1r = [];
for i=1:size(h_index,1)
    sel_h = h_index(i,1);
    figure; newplot;
    plot(recnum,var_prob(sel_h).prob_mat(var_sel_index,:)); 
    legend(char(lower(deblank(names(var_sel_index,:)))));
    title( ['h = ',num2str(sel_h) ] ); 
    axis([1 nrec 0 1]); 
    set(gca,'XTick',[1:nrec]);
    set(gca,'FontSize',8);
end

% *************************************************************** 
% Darstellung der Mengenanteile ber Prognosehorizonte h 
%       (gemittelt ber Teilperioden) 
 
ttp = round(nrec/2); 
per1 = NaN(n_names,hmax); 
per2 = NaN(n_names,hmax); 
for ii = 1 : hmax 
    aa = var_prob(ii).prob_mat(:,1:ttp); 
    bb = var_prob(ii).prob_mat(:,ttp+1:nrec); 
    saa = sum(aa') / ttp; 
    sbb = sum(bb') / (nrec - ttp); 
    per1(:,ii) = saa'; 
    per2(:,ii) = sbb'; 
end 
 
figure; newplot;
subplot(2,1,1); 
plot(hind,per1(var_sel_index,:)); 
legend(char(lower(deblank(names(var_sel_index,:)))));
title( ['mean over 1st half of sample'] ); 
axis([1 hmax 0 1]); 
set(gca,'XTick',[1:hmax],'XTickLabel',[1:hmax],'XTickMode','manual');
set(gca,'FontSize',8);

subplot(2,1,2); 
plot(hind,per2(var_sel_index,:)); 
legend(char(lower(deblank(names(var_sel_index,:)))));
title( ['mean over 2nd half of sample'] ); 
axis([1 hmax 0 1]); 
set(gca,'XTick',[1:hmax],'XTickLabel',[1:hmax],'XTickMode','manual');
set(gca,'FontSize',8);

% *************************************************************** 
% Darstellung der Mengenanteile ber Prognosehorizonte h 
%       (gemittelt ber Teilperioden) 
 
ttp = nrec; 
per1 = NaN(n_names,hmax); 
for ii = 1 : hmax 
    aa = var_prob(ii).prob_mat(:,1:ttp); 
    saa = sum(aa') / ttp; 
    per1(:,ii) = saa'; 
end 
 
figure; newplot;
plot(hind,per1(var_sel_index,:)); 
legend(char(lower(deblank(names(var_sel_index,:)))));
title( ['mean over sample'] ); 
axis([1 hmax 0 1]); 
set(gca,'XTick',[1:hmax],'XTickLabel',[1:hmax],'XTickMode','manual');
set(gca,'FontSize',8);
