function [lam,lamspar,phi,phistar,psim,sigeta,sigeps,betam,rho,tau,ft,ftstar]=f_initialize_values(data,modparam,param_init)
% out: lam (nvarsxnf), lamspar, phi(nfxnf*philag), psim(nvarsxpsilag), sigeta (nfxnf)
% sigeps (nvarsx1), betam (nvarsxnf), rho (nfx1)
% tau (nfx1)

% modparam
param_str_vec={'it','it0','rth','nf','s0','prior','philag','psilag',...
               'utz','f_ind','bf','const','m_adj','s_adj','normp'};
for i=1:size(param_str_vec,2)
    param_str=param_str_vec{1,i};
    eval([param_str,'=','modparam.',param_str,';']);
end

% param_init
param_str_vec={'tau0','beta0','rho0','p0','P0inf','q0','Q0inf','sigeps0', ...
               'sigetanu0','sigetaS0','er0'};
for i=1:size(param_str_vec,2)
    param_str=param_str_vec{1,i};
    eval([param_str,'=','param_init.',param_str,';']);
end

% prepare data
y_raw=data.data_fin;
y=f_standardise(y_raw);
nobs=size(y,1);
nvars=size(y,2);
N=nvars;

%phi
phi=zeros(nf,nf*philag);
phistar=zeros(nf,nf*philag);
if philag
    if ~f_ind
    phistar=reshape(p0+chol(inv(P0inf))'*randn(nf^2*philag,1),nf*philag,nf)';
    phistar([1:nf]+[0:nf-1]*nf)=abs(phistar([1:nf]+[0:nf-1]*nf));
    while any(abs(eig([phistar;eye(nf*(philag-1),nf*philag)]))>1)
        phistar=reshape(p0+chol(inv(P0inf))'*randn(nf^2*philag,1),nf*philag,nf)';
        phistar([1:nf]+[0:nf-1]*nf)=abs(phistar([1:nf]+[0:nf-1]*nf));
    end
    elseif f_ind
        for j=1:nf
        phistar(j,[0:(philag-1)]*nf+j)=(p0(j,:)'+chol(inv(P0inf(:,:,j)))'*randn(philag,1))';
        end
        while any(abs(eig([phistar;eye(nf*(philag-1),nf*philag)]))>1)
            for j=1:nf
            phistar(j,[0:(philag-1)]*nf+j)=(p0(j,:)'+chol(inv(P0inf(:,:,j)))'*randn(philag,1))';
            end
        end
    end
        
end

% psim
psim=zeros(nvars,psilag);

% sig
sigeta=~normp*eye(nf)+ normp*f_invwishart(sigetanu0,sigetaS0);
sigeps=1./gamrnd(sigeps0(:,1),1./sigeps0(:,2));

%tau0,beta0,rho0
tau=tau0(:,2)./(tau0(:,1)-1);
rho=[];
betam=[];

uz_ind=[];
if utz
    for j=1:(nf-1);
        uz_ind=[ uz_ind j*N+[1:j]];
    end
end

if ~prior
    lamspar=randn(N,nf).*kron(sqrt(tau),ones(1,N))';
    if utz
        lamspar(uz_ind)=0;
    end
elseif prior
    rho=rho0(:,2);%zeros(nf,1);
    lamspar=zeros(N,nf);
    for j=1:nf
        %rho(j)=mean(betarnd(ones(1000,1).*prod(rho0(j,:),2),ones(1000,1).*rho0(j,1).*(1-rho0(j,2))));
        pp=rho(j);
        if prior==2;
            pp=pp*beta0(j,2);
        end
        podd=log(pp/(1-pp));
        podd=exp(podd)./(exp(podd)+1);

        lan0=(rand(N-utz*(j-1),1)<=podd);
        while all(~lan0)
            lan0=(rand(N-utz*(j-1),1)<=podd);
        end
        if utz
            lan0=[zeros(j-1,1)==1; lan0];
        end
        lamspar(lan0,j)=sqrt(tau(j)).*abs(randn(sum(lan0),1));
    end
    
    % tau,betam,rho
    MCh=100;
    it0h=0;
    tau=tau0(:,2)./(tau0(:,1)-1);%;1./gamrnd(tau0(:,1),1./tau0(:,2));
    tau_old=tau;
    rho_old=rho;
    rhomc=zeros(nf,MCh-it0h);
    if prior==2;
        betam=zeros(nvars,nf);
        betamc=zeros(nvars,nf,MCh-it0h);
    end

    taupr=tau0;
    rhopr=[prod(rho0,2) rho0(:,1).*(1-rho0(:,2))];
    taup=zeros(nf,2);

    for j=1:nf;
        lan0=lamspar(:,j)~=0;
        slan0=sum(lan0);
        rhoN=slan0;
        simbe=find(~lan0);
        taup(j,:)=taupr(j,:) + [0.5*sum(lan0) 0.5*sum(lamspar(lan0,j).^2)];
        tau(j)=1./gamrnd(taup(j,1),1./taup(j,2));
        for m=1:MCh
            if prior==2
                podd=(1-beta0(j,2))*rho_old(j)/(1-rho_old(j));
                podd=podd/(1+podd);
                ben0=(rand(N-slan0-(j-1)*utz,1))<=podd;
                if utz
                    ben0=[zeros(j-1,1)==1;ben0];
                end
                betam(simbe(ben0),j)= betarnd(kron(ones(sum(ben0),1),prod(beta0(j,:))),kron(ones(sum(ben0),1),beta0(j,1)*(1-beta0(j,2))+1));
                betam(lan0,j)=betarnd(kron(ones(slan0,1),prod(beta0(j,:))+1),kron(ones(slan0,1),beta0(j,1)*(1-beta0(j,2))));
                rhoN=sum(ben0)+slan0;
            end
            rhop(j,:)= rhopr(j,:) + [ rhoN N-rhoN-(j-1)*utz];
            rho(j)=betarnd(rhop(j,1),rhop(j,2));
            if m>it0h
                rhomc(j,m-it0h)=rho(j);
                if prior==2;
                betamc(:,j,m-it0h)=betam(:,j);
                end
            end
        end
        %rho(j)=mean(rhomc(j,:));
        if prior==2;
        betam(:,j)=mean(betamc(:,j,:),3);
        end
    end
    clear rhomc betamc
end

s_ind=f_checkpositivity(lamspar);
for j=s_ind
    lamspar(:,j)=-lamspar(:,j);
end

[ve,va]=eig(lamspar'*lamspar);
H=ve*sqrt(va)*ve';
HI=ve*sqrt(va)^-1*ve';
lam=lamspar*HI*normp+~normp*lamspar;

[ve,va]=eig(sigeta);
H=(ve*sqrt(va)*ve');
HI=ve*sqrt(va)^-1*ve';

for j=1:philag;
    phi(:,(j-1)*nf+1:j*nf)= H*phistar(:,(j-1)*nf+1:j*nf)*HI;
end

ft=zeros(nobs,nf);
ftstar=zeros(nobs,nf);

end
