clear all
close all

prepare_pathsmodels

%
% code until here exactly the same as in estimate_sparmod_variants
%

% loop evaluation and col change
tstart=tic;
n_mod=size(modparam_mat,2);
for i=1:n_mod
    disp(' ');
    disp(['model ',num2str(i),' out of ',num2str(n_mod)]);
    modparam=modparam_mat(i).modparam;
    % load estimation results
    nf=modparam.nf;prior=modparam.prior;s0=modparam.s0;utz=modparam.utz;
    res_string=['results','_k',num2str(nf),'_prior',num2str(prior), ...
                '_s',num2str(s0*100,'%03.0f'),'_utz',num2str(utz),'_final'];
    disp(res_string);
    folder_load='.\results_final\';
    str=([folder_load,res_string]);
    load(str,'results');
    lamdraws=results.lamstarmc;
    fdraws=results.fstarmc;
    % evaluate draws: acf, geweke, etc.
    it_sel=1:size(lamdraws,3);
    folder_save='.\results_final_eval_draws\';
    flag_longsmall='small'; % 'small' does not store all results
    f_eval_draws(modparam,lamdraws,fdraws,it_sel,folder_save,flag_longsmall);
    close all
    clear modparam
end

elt=toc(tstart)/(60*60);
disp(' ');
disp(['elapsed time for final conv check ',num2str(elt),' hours']);

