% prepare paths and model specifications

% path
base_dir1 = '.\';
addpath(genpath(base_dir1));
addpath([base_dir1,'src\']);
addpath([base_dir1,'src\iris\']);
addpath([base_dir1,'src\lesage\']);
base_dir = base_dir1;

% read data
disp(' ');
disp('loading data ...');
data_dir  = '.\data\';
data_string = 'pwt70_w_country_names';
str = ([data_dir data_string '.mat']);
load(str,'data');

str_name_out='pwt';

% get dates available
disp(' ');
disp('full sample:');
disp([' no series ' num2str(size(data.data_fin,2))]);
disp([' no obs    ' num2str(size(data.data_fin,1))]);
disp([' sample    ' num2str(data.dates(1,1)) ' to ' ...
                    num2str(data.dates(end,1)) ]);
              
%
% define hyperparameters that are equal to all models
%
it=60000; %number of iterations
it0=20000; %burn-in phase
rth=4; % save every rth draw
philag=2; % autocorrelation length of common factor
psilag=1; % autocorrelation length of idiosyncratic component
bf=0; %flag to retain the posterior moments of the model parameters
f_ind=0;
const=0; %flag to include a constant, sigswitch=0; %flag for switching covariance matrix
m_adj=0;  %flag to demean data
s_adj=0;  %flag to standardize data (implemented only with m_adj=1 together)
normp=0; %flag to use 'switching' algorithm (sampling f_t based on lambda'lambda=I)

%
% define model variants
%
modparam_mat={};

prior=1; 

% nf=1
nf=1;utz=0;s0=0.5;
modparam_mat(1).modparam=struct('it',it,'it0',it0,'rth',rth,'nf',nf,'s0',s0, ...
                    'prior',prior,'philag',philag,'psilag',psilag,'utz',utz, ...
                    'f_ind',f_ind,'bf',bf,'const',const,'m_adj',m_adj,'s_adj',s_adj,'normp',normp);
% nf=2
nf=2;utz=0;s0=0.5;
modparam_mat(2).modparam=struct('it',it,'it0',it0,'rth',rth,'nf',nf,'s0',s0, ...
                    'prior',prior,'philag',philag,'psilag',psilag,'utz',utz, ...
                    'f_ind',f_ind,'bf',bf,'const',const,'m_adj',m_adj,'s_adj',s_adj,'normp',normp);
% nf=3
nf=3;utz=0;s0=0.5;
modparam_mat(3).modparam=struct('it',it,'it0',it0,'rth',rth,'nf',nf,'s0',s0, ...
                    'prior',prior,'philag',philag,'psilag',psilag,'utz',utz, ...
                    'f_ind',f_ind,'bf',bf,'const',const,'m_adj',m_adj,'s_adj',s_adj,'normp',normp);
% nf=4
nf=4;utz=0;s0=0.5;
modparam_mat(4).modparam=struct('it',it,'it0',it0,'rth',rth,'nf',nf,'s0',s0, ...
                    'prior',prior,'philag',philag,'psilag',psilag,'utz',utz, ...
                    'f_ind',f_ind,'bf',bf,'const',const,'m_adj',m_adj,'s_adj',s_adj,'normp',normp);

prior=2; 

% nf=1
nf=1;utz=0;s0=0.5;
modparam_mat(5).modparam=struct('it',it,'it0',it0,'rth',rth,'nf',nf,'s0',s0, ...
                    'prior',prior,'philag',philag,'psilag',psilag,'utz',utz, ...
                    'f_ind',f_ind,'bf',bf,'const',const,'m_adj',m_adj,'s_adj',s_adj,'normp',normp);
% nf=2
nf=2;utz=0;s0=0.5;
modparam_mat(6).modparam=struct('it',it,'it0',it0,'rth',rth,'nf',nf,'s0',s0, ...
                    'prior',prior,'philag',philag,'psilag',psilag,'utz',utz, ...
                    'f_ind',f_ind,'bf',bf,'const',const,'m_adj',m_adj,'s_adj',s_adj,'normp',normp);
% nf=3
nf=3;utz=0;s0=0.5;
modparam_mat(7).modparam=struct('it',it,'it0',it0,'rth',rth,'nf',nf,'s0',s0, ...
                    'prior',prior,'philag',philag,'psilag',psilag,'utz',utz, ...
                    'f_ind',f_ind,'bf',bf,'const',const,'m_adj',m_adj,'s_adj',s_adj,'normp',normp);
% nf=4
nf=4;utz=0;s0=0.5;
modparam_mat(8).modparam=struct('it',it,'it0',it0,'rth',rth,'nf',nf,'s0',s0, ...
                    'prior',prior,'philag',philag,'psilag',psilag,'utz',utz, ...
                    'f_ind',f_ind,'bf',bf,'const',const,'m_adj',m_adj,'s_adj',s_adj,'normp',normp);

prior=1; 
                
% nf=3;utz=0s0=0.25;
nf=3;utz=0;s0=0.25;
modparam_mat(9).modparam=struct('it',it,'it0',it0,'rth',rth,'nf',nf,'s0',s0, ...
                    'prior',prior,'philag',philag,'psilag',psilag,'utz',utz, ...
                    'f_ind',f_ind,'bf',bf,'const',const,'m_adj',m_adj,'s_adj',s_adj,'normp',normp);
% nf=3;utz=0;s0=0.75;
nf=3;utz=0;s0=0.75;
modparam_mat(10).modparam=struct('it',it,'it0',it0,'rth',rth,'nf',nf,'s0',s0, ...
                    'prior',prior,'philag',philag,'psilag',psilag,'utz',utz, ...
                    'f_ind',f_ind,'bf',bf,'const',const,'m_adj',m_adj,'s_adj',s_adj,'normp',normp);

prior=2; 
                
% nf=3;utz=0s0=0.25;
nf=3;utz=0;s0=0.25;
modparam_mat(11).modparam=struct('it',it,'it0',it0,'rth',rth,'nf',nf,'s0',s0, ...
                    'prior',prior,'philag',philag,'psilag',psilag,'utz',utz, ...
                    'f_ind',f_ind,'bf',bf,'const',const,'m_adj',m_adj,'s_adj',s_adj,'normp',normp);
% nf=3;utz=0;s0=0.75;
nf=3;utz=0;s0=0.75;
modparam_mat(12).modparam=struct('it',it,'it0',it0,'rth',rth,'nf',nf,'s0',s0, ...
                    'prior',prior,'philag',philag,'psilag',psilag,'utz',utz, ...
                    'f_ind',f_ind,'bf',bf,'const',const,'m_adj',m_adj,'s_adj',s_adj,'normp',normp);

