function [lamstarmc_out,fstarmc_out] = f_signchange(lamstarmc,fstarmc,plot_flag,fig_str1,folder)

N = size(lamstarmc,1);
r = size(lamstarmc,2);
nrep = size(lamstarmc,3);
T = size(fstarmc,1);

r2mat=nan(nrep-1,r);
for i=1:r
    for j=1:nrep-1
        r2_fac=corrcoef([squeeze(fstarmc(:,i,end)),squeeze(fstarmc(:,i,j))]);
        r2mat(j,i)=r2_fac(1,2);
    end
end
if strcmp(plot_flag,'on')
    figure; newplot;
    plot(r2mat);
    v = axis;
    axis([v(1) v(2) -1.0 1.0]);
    title('f raw rep');
    fig_str=[fig_str1,'_fdraws_corrbeforesignchange'];
    set(gcf,'name',fig_str);
    save_fig_str=[folder,fig_str];
    saveas(gcf,save_fig_str);
end

r2matneg_index = logical(r2mat<0); % [r2mat,r2matneg_index,r2matpos,logical(r2matpos<0)]
r2matneg_index = logical([r2matneg_index;zeros(1,r)]); % note: r2 computed relative to last rep!

r2matneg_index_T = repmat(r2matneg_index,[1,1,T]);
fstarmc2 = permute(fstarmc,[3,2,1]);
fstarmc2(r2matneg_index_T) = fstarmc2(r2matneg_index_T)*(-1);
fstarmc2 = permute(fstarmc2,[3,2,1]);

r2matneg_index_N = repmat(r2matneg_index,[1,1,N]);
lamstarmc2 = permute(lamstarmc,[3,2,1]);
lamstarmc2(r2matneg_index_N) = lamstarmc2(r2matneg_index_N)*(-1);
lamstarmc2 = permute(lamstarmc2,[3,2,1]);

% if strcmp(plot_flag,'on')
%     r2mat = nan(nrep-1,r);
%     for i=1:r
%         r2vec = nan(nrep-1,1);
%         for rep=1:nrep-1
%             r2 = corrcoef(fstarmc2(:,i,end),fstarmc2(:,i,rep));
%             r2vec(rep,1) = r2(1,2);
%         end
%         r2mat(:,i) = r2vec;
%     end
%     figure; newplot;
%     plot(r2mat);
%     v = axis;
%     axis([v(1) v(2) -1.0 1.0]);
%     title('f reordered rep');
%     fig_str=[fig_str1,'_fdraws_corraftersignchange'];
%     set(gcf,'name',fig_str);
%     save_fig_str=[folder,fig_str];
%     saveas(gcf,save_fig_str);
% end

% if strcmp(plot_flag,'on')
%     r2mat = nan(nrep-1,r);
%     for i=1:r
%         r2vec = nan(nrep-1,1);
%         for rep=1:nrep-1
%             r2 = corrcoef(lamstarmc2(:,i,end),lamstarmc2(:,i,rep));
%             r2vec(rep,1) = r2(1,2);
%         end
%         r2mat(:,i) = r2vec;
%     end
%     figure; newplot;
%     plot(r2mat);
%     v = axis;
%     axis([v(1) v(2) -1.0 1.0]);
%     title('lam reordered rep');
%     fig_str=[fig_str1,'_lamdraws_corraftersignchange'];
%     set(gcf,'name',fig_str);
%     save_fig_str=[folder,fig_str];
%     saveas(gcf,save_fig_str);
% end

lamstarmc_out = lamstarmc2;
fstarmc_out = fstarmc2;


%
% fig: corr of final lam, f draw versus all other draws
% 
% corr f draws
if strcmp(plot_flag,'on')
    n_it=nrep;nf=r;fdraws=fstarmc2;lamdraws=lamstarmc2;
    r2mat_fac=nan(n_it-1,nf);r2mat_fac_cross=nan(nf*(nf-1)/2,n_it-1);r2mat_fac_cross_name_str=cell(nf*(nf-1)/2,1);
    for j=1:n_it-1
        kk=1;
        for nf_index=1:nf
            r2_fac=corrcoef([squeeze(fdraws(:,nf_index,end)),squeeze(fdraws(:,nf_index,j))]);
            r2mat_fac(j,nf_index)=r2_fac(1,2);
            for k=1:nf
                if nf_index>k
                    r2_fac_cross=corrcoef([squeeze(fdraws(:,nf_index,end)),squeeze(fdraws(:,k,j))]);
                    r2mat_fac_cross(kk,j)=r2_fac_cross(1,2);
                    if j==1
                        name_r2_str=['r',num2str(nf_index),'c',num2str(k)];
                        r2mat_fac_cross_name_str{kk,1}=name_r2_str;
                    end
                    kk=kk+1;
                end
            end
        end
    end
    r2mat_fac_cross=r2mat_fac_cross';
    % own corr
    figure; newplot;
    plot(r2mat_fac);
    v = axis;
    axis([v(1) v(2) -1.0 1.0]);
    title('pearson corr of f(:,:,end) and f(:,:,1:end-1)');
    fig_str=[fig_str1,'_fdraws_corraftersignchange_own'];
    set(gcf,'name',fig_str);
    save_fig_str=[folder,fig_str];
    saveas(gcf,save_fig_str);
    % cross corr
    figure; newplot;
    n_sub=size(r2mat_fac_cross,2);
    for j=1:n_sub
        subplot(n_sub,1,j);
        plot(r2mat_fac_cross(:,j));
        title(['pearson corr across factors f(:,i,end) and f(:,j,1:end-1): ',r2mat_fac_cross_name_str{j,1}]);
        v = axis;
        axis([v(1) v(2) -1.0 1.0]);
    end
    fig_str=[fig_str1,'_fdraws_corraftersignchange_cross'];
    set(gcf,'name',fig_str);
    save_fig_str=[folder,fig_str];
    saveas(gcf,save_fig_str);
    clear r2mat_fac r2mat_fac_cross
    
    % corr lam draws
    r2mat_lam=nan(n_it-1,nf);r2mat_lam_cross=nan(nf*(nf-1)/2,n_it-1);r2mat_lam_cross_name_str=cell(nf*(nf-1)/2,1);
    for j=1:n_it-1
        kk=1;
        for nf_index=1:nf
            r2_lam=corrcoef([squeeze(lamdraws(:,nf_index,end)),squeeze(lamdraws(:,nf_index,j))]);
            r2mat_lam(j,nf_index)=r2_lam(1,2);
            for k=1:nf
                if nf_index>k
                    r2_lam_cross=corrcoef([squeeze(lamdraws(:,nf_index,end)),squeeze(lamdraws(:,k,j))]);
                    r2mat_lam_cross(kk,j)=r2_lam_cross(1,2);
                    if j==1
                        name_r2_str=['r',num2str(nf_index),'c',num2str(k)];
                        r2mat_lam_cross_name_str{kk,1}=name_r2_str;
                    end
                    kk=kk+1;
                end
            end
        end
    end
    r2mat_lam_cross=r2mat_lam_cross';
    % own corr
    figure; newplot;
    plot(r2mat_lam);
    v = axis;
    axis([v(1) v(2) -1.0 1.0]);
    title('pearson corr of lam(:,:,end) and lam(:,:,1:end-1)');
    fig_str=[fig_str1,'_lamdraws_corraftersignchange_own'];
    set(gcf,'name',fig_str);
    save_fig_str=[folder,fig_str];
    saveas(gcf,save_fig_str);
    % cross corr
    figure; newplot;
    n_sub=size(r2mat_lam_cross,2);
    for j=1:n_sub
        subplot(n_sub,1,j);
        plot(r2mat_lam_cross(:,j));
        title(['pearson corr across lam lam(:,i,end) and lam(:,j,1:end-1): ',r2mat_lam_cross_name_str{j,1}]);
        v = axis;
        axis([v(1) v(2) -1.0 1.0]);
    end
    fig_str=[fig_str1,'_lamdraws_corraftersignchange_cross'];
    set(gcf,'name',fig_str);
    save_fig_str=[folder,fig_str];
    saveas(gcf,save_fig_str);
    clear r2mat_lam r2mat_lam_cross
end

end


