clear all
close all
rng default 
dbstop if error

poolobj = gcp('nocreate');
delete(poolobj);

prepare_pathsdgpsmodels

tstart=tic;
for s0_index=1:length(s0_dgp_vec)
    s0_sim=s0_dgp_vec(s0_index);
    disp(' ');
    disp(['s0 ',num2str(s0_sim)]);
    disp(' ');
    % for rep=1:n_rep
    parpool(50);
    parfor rep=1:n_rep
        rho0_sim=kron(ones(nf_sim,1),[30,s0_sim]); %rho0_1=precision, rho0_2=mean
        disp([' rep ',num2str(rep),' from ',num2str(n_rep)]);
        %
        % estimation with: different a) priors, b) factors
        for prior_index=1:n_prior
            prior=prior_est_vec(1,prior_index); % prior on factor loadings: 0: normal (hierarchical); 1: one-layer sparse; 2:two-layer sparse;
            for nf_index=1:nf_maxindex
                nf=nf_vec(1,nf_index);
                disp(['  s0 ' num2str(s0_sim,'%4.2f') ', rep ' int2str(rep) ', prior ' int2str(prior) ', nf ' int2str(nf)]);
                % setup_params_estimation
                it=6000;
                it0=2000; 
                rth=2; % save every rth draw
                philag=1; % autocorrelation length of common factor
                psilag=0; % autocorrelation length of idiosyncratic component
                bf=0; %flag to retain the posterior moments of the model parameters
                const=0; %flag to include a constant
                f_ind=0;
                m_adj=0; %flag to demean data
                s_adj=0; %flag to standardize data (implemented only with m_adj=1 together)
                normp=0; %flag to use 'switching' algorithm (sampling f_t based on lambda'lambda=I)
                utz=0; %flag to impose upper triangular zero loadings (only in combination with norm=0)
                %
                % modparam=struct('it',it,'it0',it0,'rth',rth,'nf',nf,'s0',s0_sim, ...
                %     'prior',prior,'philag',philag,'psilag',psilag,'utz',utz, ...
                %     'f_ind',f_ind,'bf',bf,'const',const,'m_adj',m_adj,'s_adj',s_adj,'normp',normp);
                % load estimation results
                res_string=['results','_k',num2str(nf),'_prior',num2str(prior), ...
                            '_s',num2str(s0_sim*100,'%03.0f'),'_utz',num2str(utz),'_rep',num2str(rep)];
                str=([folder,res_string]);
                results2=load(str,'results');
                results=results2.results;
                lamdraws=results.lamstarmc;
                fdraws=results.fstarmc;
                results=[];
                % folder_save: path to store new draws
                folder_save='.\results_final\';
                if not(exist(folder_save,'dir')==7)
                    mkdir(folder_save);
                end
                % kmedoids clustering, keep only permutations of original ordering,
                % watch out the number of draws! k-medoids will fail with n_it>10k!
                clust_flag='on';
                if strcmp(clust_flag,'on')
                    n_it=min(2000,size(lamdraws,3)); 
                    it_sel=size(lamdraws,3)-n_it+1:size(lamdraws,3);
                    lamdraws_base=lamdraws(:,:,it_sel);
                    fdraws_base=fdraws(:,:,it_sel);
                    [lamstarmc_out,fstarmc_out]=f_colchange_fbased(lamdraws_base,fdraws_base,nf);
                    n_it_clust=size(lamstarmc_out,3);
                    n_it=n_it_clust;
                    disp(['draws after clust ',num2str(n_it_clust)]);
                    legend_str_vec=cell(1,nf);
                    lamdraws=lamstarmc_out;
                    fdraws=fstarmc_out;
                    results.lamstarmc=lamdraws; % over write old draws in results struct
                    results.fstarmc=fdraws;
                end
                % sequential correlation clustering based on factor time-series
                % patterns by sylvia
                clust_flag='off';
                if strcmp(clust_flag,'on')
                    % case-specific clustering
                    if rep==1
                        n_it=min(2000,size(lamdraws,3)); 
                        it_sel=size(lamdraws,3)-n_it+1:size(lamdraws,3);
                        lamdraws_base=lamdraws(:,:,it_sel);
                        fdraws_base=fdraws(:,:,it_sel);
                        [fstarmc_out,lamstarmc_out,it_sel]=f_identify_factors_new(fdraws_base,lamdraws_base,prior);
                        n_it_clust=size(it_sel.in,2);
                        n_it=n_it_clust;
                        disp(['draws after clust ',num2str(n_it_clust)]);
                        fstarmc_out=fstarmc_out(:,:,it_sel.in);
                        lamstarmc_out=lamstarmc_out(:,:,it_sel.in);
                        nf_clust=size(fstarmc_out,2);
                        if nf_clust~=nf
                            disp(['warning: nf_clust ',num2str(nf_clust),', nf ',num2str(nf)]);
                        end
                        lamdraws=lamstarmc_out;
                        fdraws=fstarmc_out;
                        results.lamstarmc=lamdraws; % over write old draws in results struct
                        results.fstarmc=fdraws;
                    else
                        % rest of models
                        n_it=min(2000,size(lamdraws,3)); 
                        it_sel=size(lamdraws,3)-n_it+1:size(lamdraws,3);
                        lamdraws_base=lamdraws(:,:,it_sel);
                        fdraws_base=fdraws(:,:,it_sel);
                        [fstarmc_out,lamstarmc_out,it_sel]=f_identify_factors_new(fdraws_base,lamdraws_base,prior);
                        n_it_clust=size(it_sel.in,2);
                        n_it=n_it_clust;
                        disp(['draws after clust ',num2str(n_it_clust)]);
                        fstarmc_out=fstarmc_out(:,:,it_sel.in);
                        lamstarmc_out=lamstarmc_out(:,:,it_sel.in);
                        nf_clust=size(fstarmc_out,2);
                        if nf_clust~=nf
                            disp(['warning: nf_clust ',num2str(nf_clust),', nf ',num2str(nf)]);
                        end
                        lamdraws=lamstarmc_out;
                        fdraws=fstarmc_out;
                        results.lamstarmc=lamdraws; % over write old draws in results struct
                        results.fstarmc=fdraws;
                        % sign change
                        it_sel2=1:size(fdraws,3);
                        it_sel=size(lamdraws,3)-n_it+1:size(lamdraws,3);
                        lamdraws_base=lamdraws(:,:,it_sel2);
                        fdraws_base=fdraws(:,:,it_sel2);
                        disp(' ');
                        disp('correcting signs ...');
                        [lamdraws,fdraws]=f_signchange(lamdraws_base,fdraws_base,'on','fig_temp','.\');
                        disp('sign change done');
                    end
                end
                % save new draws under folder_save
                res_string_save=[res_string,'_final'];
                str=([folder_save,res_string_save]);
                f_save(str,results);
                results=[];
            end
        end
    end
    poolobj = gcp('nocreate');
    delete(poolobj);
end

elt=toc(tstart)/(60*60);
disp(' ');
disp(['elapsed time for clustering ',num2str(elt),' hours']);
