function [options,invalid] = passopt(default,varargin)

if isstruct(default), options = default;
  else options = cell2struct(default(2:2:end),default(1:2:end),2); end

% function body ---------------------------------------------------------------------------------------------

if nargin == 1, return, end

if nargin == 2 && isstruct(varargin{1})
  useroptions = varargin{1};
elseif nargin == 2 && iscell(varargin{1});
  aux = varargin{1};
  aux(1:2:nargin-1) = lower(aux(1:2:nargin-1));
  useroptions = cell2struct(aux(2:2:end),aux(1:2:end),2);
elseif nargin > 2 && iscellstr(varargin(1:2:nargin-1))
  varargin(1:2:nargin-1) = lower(varargin(1:2:nargin-1));
  useroptions = cell2struct(varargin(2:2:end),varargin(1:2:end),2);
else
  error('Incorrect list of user options.');
end

username = fieldnames(useroptions);
invalid = cell([0,1]);
for i = 1 : length(username)
  try, options.(username{i}); catch, invalid{end+1} = username{i}; end
  options.(username{i}) = useroptions.(username{i});
end

if ~isempty(invalid), warning('iris:options','Invalid or obsolete option: ''%s'' (option not used).\n',invalid{:}); end

end % of primary function -----------------------------------------------------------------------------------